/* * * * * * * * * * * * *  BEGIN LICENSE BLOCK * * * * * * * * * * * * * * * *
   * Version: MPL 1.1/GPL 2.0/LGPL 2.1
   *
   * The contents of this file are subject to the Mozilla Public License Version
   * 1.1 (the "License"); you may not use this file except in compliance with
   * the License. You may obtain a copy of the License at
   * http://www.mozilla.org/MPL/
   * 
   * Software distributed under the License is distributed on an "AS IS" basis,
   * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
   * for the specific language governing rights and limitations under the
   * License.
   *
   * The Original Code is Juergen Binder's Browse Images Code
   *
   * The Initial Developer of the Original Code is Juergen Binder.
   * Portions created by Juergen Binde are Copyright (C) 2005
   * Juergen Binder. All Rights Reserved.
   *
   * Contributor(s): Juergen Binder.
   *
   * Alternatively, the contents of this file may be used under the terms of
   * either the GNU General Public License Version 2 or later (the "GPL"), or
   * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
   * in which case the provisions of the GPL or the LGPL are applicable instead
   * of those above. If you wish to allow use of your version of this file only
   * under the terms of either the GPL or the LGPL, and not to allow others to
   * use your version of this file under the terms of the MPL, indicate your
   * decision by deleting the provisions above and replace them with the notice
   * and other provisions required by the LGPL or the GPL. If you do not delete
   * the provisions above, a recipient may use your version of this file under
   * the terms of any one of the MPL, the GPL or the LGPL.
   * * * * * * * * * * * *  END LICENSE BLOCK * * * * * * * * * * * * * * * * */


var prefBranch = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("browseimages.");

var props = document.getElementById("g-strings");

var availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
var enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");

var addButton = document.getElementById("browseimages.options.statusbar.menuitems.buttons.add");

var removeButton = document.getElementById("browseimages.options.statusbar.menuitems.buttons.remove");

function BIOinit() {
    
    var width  = prefBranch.getIntPref("optionsDialogWidth")
    var height = prefBranch.getIntPref("optionsDialogHeight");
    resizeTo(width, height);
    
    if(availableList == null) {
        availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    }
    
    if(enabledList == null) {
        enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    }
    
    if(addButton == null) {
        addButton = document.getElementById("browseimages.options.statusbar.menuitems.buttons.add");
    }
    
    if(removeButton == null) {
        removeButton = document.getElementById("browseimages.options.statusbar.menuitems.buttons.remove");
    }
    
    if(prefBranch.getBoolPref("centerImages")) {
        document.getElementById("browseimages.options.centerimages").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.centerimages").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("autoBack")) {
        document.getElementById("browseimages.options.autoBack").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.autoBack").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("statusbarMenu")) {
        document.getElementById("browseimages.options.statusbarMenu").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.statusbarMenu").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("toolsMenu")) {
        document.getElementById("browseimages.options.toolsMenu").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.toolsMenu").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("autoScan")) {
        document.getElementById("browseimages.options.autoScan").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.autoScan").setAttribute("checked","false");
    }
    
    if(prefBranch.getBoolPref("goMenu")) {
        document.getElementById("browseimages.options.goMenu").setAttribute("checked","true");
    } else {
        document.getElementById("browseimages.options.goMenu").setAttribute("checked","false");
    }
    
    document.getElementById("browseimage.options.historyMenuOptions.index.group")
                        .selectedIndex = 2 - prefBranch.getIntPref("back_history_menu_backToIndex");
    
    document.getElementById("browseimage.options.historyMenuOptions.back.group")
                        .selectedIndex = 2 - prefBranch.getIntPref("back_history_menu_prevImg");
    
    document.getElementById("browseimage.options.historyMenuOptions.forward.group")
                        .selectedIndex = 2 - prefBranch.getIntPref("forward_history_menu_nextImg");
    
    document.getElementById("browseimage.options.historyMenuOptions.count")
                       .value = prefBranch.getIntPref("max_history_menu_items");
    
    var txtbx = document.getElementById(
                                "browseimage.options.historyMenuOptions.count")
                                .inputField;
    
    txtbx.setAttribute("style", "text-align:right;");
    
    
    var availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
    var enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    
    var lists = prefBranch.getCharPref("statusbarMenuitems").split("|");
    
    var availableItems = lists[0].split(";");
    var enabledItems   = lists[1].split(";");
    
    if(props == null) {
        props = document.getElementById("g-strings");
    }
    
    for(var i = 0; i < availableItems.length; i++) {
        try {
            availableList.appendItem(props.getString(availableItems[i]), availableItems[i]);
        } catch(e) {}
    }
    
    for(var j = 0; j < enabledItems.length; j++) {
        try {
            enabledList.appendItem(props.getString(enabledItems[j]), enabledItems[j]);
        } catch(e) {}
    }
    
    if(availableList.getRowCount() > 0) {
        availableList.selectedIndex = 0;
        BIOclick(true);
    } else {
        enabledList.selectedIndex = 0;
        BIOclick(false);
    }
}


function BIOsave() {
    
    prefBranch.setIntPref("optionsDialogWidth", window.outerWidth);
    prefBranch.setIntPref("optionsDialogHeight", window.outerHeight);
    
    var availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
    var enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    
    if(document.getElementById("browseimages.options.statusbarMenu").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("statusbarMenu", 1);
    } else {
        prefBranch.setBoolPref("statusbarMenu", 0);
    }
    
    if(document.getElementById("browseimages.options.goMenu").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("goMenu", 1);
    } else {
        prefBranch.setBoolPref("goMenu", 0);
    }
    
    if(document.getElementById("browseimages.options.toolsMenu").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("toolsMenu", 1);
    } else {
        prefBranch.setBoolPref("toolsMenu", 0);
    }
    
    if(document.getElementById("browseimages.options.centerimages").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("centerImages", 1);
    } else {
        prefBranch.setBoolPref("centerImages", 0);
    }
    
    
    if(document.getElementById("browseimages.options.autoBack").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("autoBack", 1);
    } else {
        prefBranch.setBoolPref("autoBack", 0);
    }
    
    if(document.getElementById("browseimages.options.autoScan").getAttribute("checked") == "true") {
        
        prefBranch.setBoolPref("autoScan", 1);
    } else {
        prefBranch.setBoolPref("autoScan", 0);
    }
    
    prefBranch.setIntPref("back_history_menu_backToIndex", 
                        2 - document.getElementById(
                        "browseimage.options.historyMenuOptions.index.group")
                        .selectedIndex);
    
    prefBranch.setIntPref("back_history_menu_prevImg",
                        2 - document.getElementById(
                        "browseimage.options.historyMenuOptions.back.group")
                        .selectedIndex);
    
    prefBranch.setIntPref("forward_history_menu_nextImg",
                        2 - document.getElementById(
                        "browseimage.options.historyMenuOptions.forward.group")
                        .selectedIndex);
    
    prefBranch.setIntPref("max_history_menu_items", document.getElementById(
                          "browseimage.options.historyMenuOptions.count").value);
    
    var menuitemlist = new String();
    
    for(var i = 0; i < availableList.getRowCount(); i++) {
        menuitemlist += availableList.getItemAtIndex(i).value + ";";
    }
    
    menuitemlist += "|";
    
    for(i = 0; i < enabledList.getRowCount(); i++) {
        menuitemlist += enabledList.getItemAtIndex(i).value + ";";
    }
    
    prefBranch.setCharPref("statusbarMenuitems", menuitemlist);
    
}



function BIOclick(bool) {
    
    if(bool) {
        addButton.setAttribute("disabled", "false");
        removeButton.setAttribute("disabled", "true");
    } else {
        addButton.setAttribute("disabled","true");
        removeButton.setAttribute("disabled","false");
    }
}
/*
 * true => add
 * false => remove
 */
function BIOaddMenuItem(bool) {
    
    
    var sourceList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
    var targetList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    
    if(!bool) {
        var tempList = sourceList;
        sourceList = targetList;
        targetList = tempList;
    }
    
    var listitem;
    
    for(var i = 0; i < sourceList.getRowCount(); i++) {
        listitem = sourceList.getItemAtIndex(i);
        if(listitem.selected) {
            try{
                if(listitem.value != "separator" || !bool) {
                    listitem = sourceList.removeItemAt(i);
                }
                if(listitem.value != "separator" || bool) {
                    if(targetList.selectedIndex > -1) {
                        targetList.insertItemAt(targetList.selectedIndex, listitem.label, listitem.value);
                    } else {
                        targetList.appendItem(listitem.label, listitem.value);
                    }
                    
                    if(listitem.value != "separator") {
                        i--;
                    }
                    
                } else if(!bool) {
                    i--;
                }   
            } catch(ex) {
                alert(ex);
            }
        }
    }
}

/* true => moveup
*  false => movedown
*/
function BIOmove(dir) {
    
    var delta;
    var list;
    var listitem;
    var moveFirstIndex;
    var moveLastIndex;
    var dontForgetToSelect = new Array();
    
    if(addButton.getAttribute("disabled") == "true") {        
        list =  document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    } else {
        list = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    }
    
    if(dir) {
        moveFirstIndex = 1;
        moveLastIndex = list.getRowCount();
        delta = +1;
    } else {
        moveFirstIndex = list.getRowCount() - 2;
        moveLastIndex = -1;
        delta = -1;
    }
    
    for(var i = moveFirstIndex; i != moveLastIndex; i += delta) {
        listitem = list.getItemAtIndex(i)
        
        if(listitem.selected) {
            
            listitem = list.removeItemAt(i);
            
            i -= delta;
            
            if(i == list.getRowCount()) {
                listitem = list.appendItem(listitem.label, listitem.value);
            } else {
                listitem = list.insertItemAt(i, listitem.label, listitem.value);
            }
            
            dontForgetToSelect.push(listitem);
            
        } 
    }
    
    for(var j in dontForgetToSelect) {
        list.addItemToSelection(dontForgetToSelect[j]);
    }
    
}
function BIOselectAll() {
    
    var availableList = document.getElementById("browseimages.options.statusbar.menuitems.available.list");
    
    var enabledList = document.getElementById("browseimages.options.statusbar.menuitems.enabled.list");
    
    
    if(addButton.getAttribute("disabled") == "true") {
        try {
            enabledList.selectAll();
        } catch (e) {
            availableList.selectAll();
        }
    } else {
        /* could not be emtpy as separator always remains there */
        availableList.selectAll();
    }
}
